=== debian/control ===
Source: polarssl
Section: libs
Priority: optional
Maintainer: Roland Stigge <stigge@antcom.de>
Standards-Version: 3.9.5
Build-Depends: debhelper (>= 9)
Homepage: http://polarssl.org

Package: libpolarssl-dev
Architecture: any
Section: libdevel
Depends: libc6-dev, ${misc:Depends}, libpolarssl5 (= ${binary:Version})
Description: lightweight crypto and SSL/TLS library
 PolarSSL is a fork of the abandonned project XySSL. It is a lean crypto
 library providing SSL and TLS support in your programs. It features:
  - AES, Triple-DES, DES, ARC4, Camellia, XTEA
  - MD2, MD4, MD5, SHA-1, SHA-256, SHA-384, SHA-512
  - HAVEGE random number generator
  - RSA with PKCS#1 v1.5 padding
  - SSLv3 and TLSv1 client support
  - X.509 certificate and CRL reading
 .
 This package contains the static library and the header files.

Package: libpolarssl-runtime
Architecture: any
Section: libdevel
Depends: libc6-dev, ${misc:Depends}
Description: lightweight crypto and SSL/TLS library
 PolarSSL is a fork of the abandonned project XySSL. It is a lean crypto
 library providing SSL and TLS support in your programs. It features:
  - AES, Triple-DES, DES, ARC4, Camellia, XTEA
  - MD2, MD4, MD5, SHA-1, SHA-256, SHA-384, SHA-512
  - HAVEGE random number generator
  - RSA with PKCS#1 v1.5 padding
  - SSLv3 and TLSv1 client support
  - X.509 certificate and CRL reading
 .
 This package contains the runtime executables.

Package: libpolarssl5
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: lightweight crypto and SSL/TLS library
 PolarSSL is a fork of the abandonned project XySSL. It is a lean crypto
 library providing SSL and TLS support in your programs. It features:
  - AES, Triple-DES, DES, ARC4, Camellia, XTEA
  - MD2, MD4, MD5, SHA-1, SHA-256, SHA-384, SHA-512
  - HAVEGE random number generator
  - RSA with PKCS#1 v1.5 padding
  - SSLv3 and TLSv1 client support
  - X.509 certificate and CRL reading
 .
 This package contains the shared library.
